package com.xy.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.github.yitter.idgen.YitIdHelper;
import com.xy.dto.SysSystemUserDto;
import com.xy.entity.SysSystemUser;
import com.xy.mapper.SysSystemUserMapper;
import com.xy.service.SysSystemUserService;
import com.xy.utils.R;
import com.xy.utils.SaTokenUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.Data;
import lombok.experimental.Accessors;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestBody;

import static com.xy.utils.Beans.copy;

/**
 * <p>
 * 权限用户表 服务实现类
 * </p>
 *
 * @author lijin
 * @since 2022-12-09
 */
@Service
@Api(tags = "权限用户接口")
public class SysSystemUserServiceImpl extends ServiceImpl<SysSystemUserMapper, SysSystemUser> implements SysSystemUserService {

    @Override
    @ApiOperation("注册")
    public R<Boolean> register(@RequestBody @Validated SysSystemUserDto sysSystemUserDto) {
        Object loginId = SaTokenUtils.getId();
        long count = count(new LambdaQueryWrapper<SysSystemUser>()
                .eq(SysSystemUser::getAccount, sysSystemUserDto.getAccount())
                .eq(SysSystemUser::getId, loginId)
        );
        if (count > 0) {
            return R.fail("账户已存在");
        }
        SysSystemUser sysSystemUser = copy(SysSystemUser.class, sysSystemUserDto).create(Long.parseLong(loginId.toString()));
        save(sysSystemUser);
        return R.ok();
    }

}
